# coding: utf-8

"""
    IONOS Cloud - Object Storage Management API

    Object Storage Management API is a RESTful API that manages the object storage service configuration for IONOS Cloud.   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud_object_storage_management.configuration import Configuration


class RegionCapability(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'iam': 'bool',

        's3select': 'bool',
    }

    attribute_map = {

        'iam': 'iam',

        's3select': 's3select',
    }

    def __init__(self, iam=None, s3select=None, local_vars_configuration=None):  # noqa: E501
        """RegionCapability - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._iam = None
        self._s3select = None
        self.discriminator = None

        if iam is not None:
            self.iam = iam
        if s3select is not None:
            self.s3select = s3select


    @property
    def iam(self):
        """Gets the iam of this RegionCapability.  # noqa: E501

        Indicates if IAM policy based access is supported  # noqa: E501

        :return: The iam of this RegionCapability.  # noqa: E501
        :rtype: bool
        """
        return self._iam

    @iam.setter
    def iam(self, iam):
        """Sets the iam of this RegionCapability.

        Indicates if IAM policy based access is supported  # noqa: E501

        :param iam: The iam of this RegionCapability.  # noqa: E501
        :type iam: bool
        """

        self._iam = iam

    @property
    def s3select(self):
        """Gets the s3select of this RegionCapability.  # noqa: E501

        Indicates if S3 Select is supported  # noqa: E501

        :return: The s3select of this RegionCapability.  # noqa: E501
        :rtype: bool
        """
        return self._s3select

    @s3select.setter
    def s3select(self, s3select):
        """Sets the s3select of this RegionCapability.

        Indicates if S3 Select is supported  # noqa: E501

        :param s3select: The s3select of this RegionCapability.  # noqa: E501
        :type s3select: bool
        """

        self._s3select = s3select
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RegionCapability):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RegionCapability):
            return True

        return self.to_dict() != other.to_dict()
